= C++ example project scanned on SonarCloud using GitLab CI
// URIs:
:uri-qg-status: https://sonarcloud.io/dashboard?id=sonarsource-cfamily-examples_linux-autotools-gitlab-ci-sc
:img-qg-status: https://sonarcloud.io/api/project_badges/measure?project=sonarsource-cfamily-examples_linux-autotools-gitlab-ci-sc&metric=alert_status
:uri-build-status: https://gitlab.com/tomasz.kaminski/linux-autotools-gitlab-ci-sc/-/pipelines
:img-build-status: https://gitlab.com/tomasz.kaminski/linux-autotools-gitlab-ci-sc/badges/main/pipeline.svg

image:{img-build-status}[Build Status, link={uri-build-status}]
image:{img-qg-status}[Quality Gate Status,link={uri-qg-status}]

*This project is analysed on https://sonarcloud.io/dashboard?id=sonarsource-cfamily-examples_linux-autotools-gitlab-ci-sc[SonarCloud]!*

:note-caption: :information_source:
NOTE: This simple example ignores https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#analysis-cache[analysis cache] and https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#parallel-code-scan[multithreaded execution] both of which can boost analysis significantly.

It is very easy to analyze a C, C++ and Objective-C project with SonarCloud https://docs.sonarcloud.io/getting-started/gitlab/[on GitLab CI]:

. Create a `sonar-project.properties` file to store your configuration
. In your `.gitlab-ci.yml` file:
.. As the `.pre` stage  stage:
... Download the https://docs.sonarcloud.io/advanced-setup/ci-based-analysis/sonarscanner-cli/[Sonar Scanner]
... Download the https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#analysis-steps-using-build-wrapper[Build Wrapper]
... Push both binaries to cache, so they can be used in next step
.. As part of the `build` stage: 
... Install autotools-dev package
... Pull Sonar Scanner and Build Wrapper from cache
... Wrap your compilation with the Build Wrapper
... Push Sonar Scanner and build Wrapper output directory to the cache
.. As part of the `.post` stage:
... Pull build wrapper output and Sonar Scanner from cache
... Run `sonar-scanner` on build wrapper output
. Make sure that you have your token stored as a CI variable in your project (`SONAR_TOKEN`). You can request new tokens using https://sonarcloud.io/account/security/[Account/Security page].


You can take a look at the link:sonar-project.properties[sonar-project.properties] and link:.gitlab-ci.yml[.gitlab-ci.yml] to see it in practice.

= Documentation

- https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/[Documentation of the C, C++ and Objective-C plugin and its Build Wrapper]
- https://docs.sonarcloud.io/getting-started/gitlab/[Documentation of using SonarCloud with GitLab CI]
- https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#analysis-cache[Configuring C, C++ and Objective-C analysis cache]
- https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#parallel-code-scan[Configuring multithreaded execution]
- https://docs.sonarcloud.io/advanced-setup/languages/c-c-objective-c/#analysis-steps-using-compilation-database[Using compilation database (compile_commands.json)]

= Linux\Autotools

A build of the https://github.com/sonarsource-cfamily-examples/code[code repository] on a Linux platform using GNU Autotools build system.

To build the code run:
----
autoreconf --install
./configure
make clean all
----

= Code Description

An example of a flawed C++ code. The https://github.com/sonarsource-cfamily-examples/code[code repository] is meant to be compiled with different build systems using different CI pipelines on Linux, MacOS, and Windows.

The https://github.com/sonarsource-cfamily-examples/code[code repository] is forked into other repositories in https://github.com/sonarsource-cfamily-examples[this collection] to add a specific build system, platform, and CI.
The downstream repositories are analyzed either with https://www.sonarqube.org/[SonarQube] or https://sonarcloud.io/[SonarCloud].

You can find examples for:

* https://github.com/sonarsource-cfamily-examples?q=linux[Linux]
* https://github.com/sonarsource-cfamily-examples?q=macos[MacOS]
* https://github.com/sonarsource-cfamily-examples?q=windows[Windows]

Using the following build systems:

* https://github.com/sonarsource-cfamily-examples?q=cmake[CMake]
* https://github.com/sonarsource-cfamily-examples?q=autotools[GNU Autotools]
* https://github.com/sonarsource-cfamily-examples?q=xcode[Xcode]
* https://github.com/sonarsource-cfamily-examples?q=msbuild[MSBuild]

Running on the following CI services:

* https://github.com/sonarsource-cfamily-examples?q=azure[Azure DevOps]
* https://github.com/sonarsource-cfamily-examples?q=gh-actions[GitHub Actions]
* https://github.com/sonarsource-cfamily-examples?q=travis[Travis]
* https://github.com/sonarsource-cfamily-examples?q=jenkins[Jenkins]
* https://github.com/sonarsource-cfamily-examples?q=gitlab[GitLab CI]
* https://github.com/sonarsource-cfamily-examples?q=bitbucket[BitBucket Pipelines]
* Additionally, https://github.com/orgs/sonarsource-cfamily-examples/repositories?q=otherci[generic examples] demonstrate integration with other CIs and https://github.com/orgs/sonarsource-cfamily-examples/repositories?q=manual[manual-configuration examples] should help you if you are running locally.

Configured for analysis on:

* https://github.com/sonarsource-cfamily-examples?q=-sq[SonarQube]
* https://github.com/sonarsource-cfamily-examples?q=-sc[SonarCloud]

You can find also a few examples demonstrating:

* https://github.com/orgs/sonarsource-cfamily-examples/repositories?q=compdb[The use of Compilation Database (compile_commands.json)]
* https://github.com/orgs/sonarsource-cfamily-examples/repositories?q=topic%3Acoverage[Test coverage]


See link:./examples-structure.adoc[examples-structure.adoc] for a description of the structure of https://github.com/sonarsource-cfamily-examples[this GitHub organization] and the relations between its different repositories.
